diff --git a/test/unit/web/auth_policy_test.rb b/test/unit/web/auth_policy_test.rb
new file mode 100644
index 00000000..f434aa66
--- /dev/null
+++ b/test/unit/web/auth_policy_test.rb
@@ -0,0 +1,28 @@
+require "test_helper"
+require "hive/web/auth_policy"
+
+class WebAuthPolicyTest < Minitest::Test
+  def test_auto_is_authless_only_for_literal_loopback_binds
+    %w[127.0.0.1 127.12.0.99 ::1 localhost].each do |bind|
+      policy = Hive::Web::AuthPolicy.new(bind: bind, configured_mode: "auto")
+      assert_equal "none", policy.effective_mode, bind
+      assert policy.allowed?, bind
+    end
+
+    %w[0.0.0.0 :: 192.168.1.10 example.test unknown-host].each do |bind|
+      policy = Hive::Web::AuthPolicy.new(bind: bind, configured_mode: "auto")
+      assert_equal "github", policy.effective_mode, bind
+      assert policy.allowed?, bind
+    end
+  end
+
+  def test_explicit_no_auth_on_public_bind_requires_unsafe_opt_in
+    safe = Hive::Web::AuthPolicy.new(bind: "0.0.0.0", configured_mode: "none")
+    refute safe.allowed?
+    assert_match(/--unsafe-no-auth/, safe.refusal_message)
+
+    unsafe = Hive::Web::AuthPolicy.new(bind: "0.0.0.0", configured_mode: "none", unsafe_no_auth: true)
+    assert unsafe.allowed?
+    assert unsafe.unsafe?
+  end
+end
diff --git a/test/unit/web/config_test.rb b/test/unit/web/config_test.rb
index a9ed2389..8561bacc 100644
--- a/test/unit/web/config_test.rb
+++ b/test/unit/web/config_test.rb
@@ -10,6 +10,7 @@ class WebConfigTest < Minitest::Test
 
       assert_equal "127.0.0.1", cfg["bind"]
       assert_equal 4567, cfg["port"]
+      assert_equal "auto", cfg["auth"]
       assert_match(/\.web\.session_secret\z/, cfg["session_secret_file"])
     end
   end
@@ -63,4 +64,8 @@ class WebConfigTest < Minitest::Test
   def test_blank_web_session_secret_file_is_rejected
     assert_web_config_error({ "session_secret_file" => "  " }, /web\.session_secret_file/)
   end
+
+  def test_invalid_web_auth_is_rejected
+    assert_web_config_error({ "auth" => "password" }, /web\.auth/)
+  end
 end
diff --git a/test/unit/web/runtime_layout_test.rb b/test/unit/web/runtime_layout_test.rb
new file mode 100644
index 00000000..e727d30b
--- /dev/null
+++ b/test/unit/web/runtime_layout_test.rb
@@ -0,0 +1,47 @@
+require "test_helper"
+require "hive/web/runtime_layout"
+
+class WebRuntimeLayoutTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_uses_versioned_data_runtime_and_durable_state_storage
+    with_xdg_home do
+      layout = Hive::Web::RuntimeLayout.new(version: "9.8.7", package_root: "/pkg/hive")
+
+      assert_equal File.join(Hive::Paths.data_home, "web", "9.8.7"), layout.app_dir
+      assert_equal File.join(Hive::Paths.data_home, "web", "9.8.7", "bundle"), layout.bundle_path
+      assert_equal File.join(Hive::Paths.state_home, "web-storage"), layout.storage_path
+      assert_equal File.join("/pkg/hive", "web"), layout.source_app_dir
+    end
+  end
+
+  def test_completed_requires_a_matching_manifest_and_rails_app
+    with_xdg_home do
+      layout = Hive::Web::RuntimeLayout.new(version: "9.8.7")
+      FileUtils.mkdir_p(File.join(layout.app_dir, "config"))
+      File.write(File.join(layout.app_dir, "config", "application.rb"), "# app")
+      File.write(layout.manifest_path, JSON.generate("identity" => { "version" => "9.8.7" }))
+
+      assert layout.completed?({ "version" => "9.8.7" })
+      refute layout.completed?({ "version" => "9.8.8" })
+    end
+  end
+
+  def test_promote_keeps_previous_completed_runtime_until_a_later_cleanup
+    with_xdg_home do
+      layout = Hive::Web::RuntimeLayout.new(version: "9.8.7")
+      FileUtils.mkdir_p(layout.app_dir)
+      File.write(File.join(layout.app_dir, "old"), "old")
+      staging = layout.staging_dir
+      FileUtils.mkdir_p(staging)
+      File.write(File.join(staging, "new"), "new")
+
+      layout.promote!(staging)
+
+      assert_equal "new", File.read(File.join(layout.app_dir, "new"))
+      previous = Dir["#{layout.app_dir}.previous-*"]
+      assert_equal 1, previous.size
+      assert_equal "old", File.read(File.join(previous.first, "old"))
+    end
+  end
+end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab0..e43b68cb 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -48,6 +48,16 @@ class WebCommandTest < Minitest::Test
       assert_empty err, "an https origin implies a fronting proxy — no warning"
     end
   end
+
+  def test_refuses_explicit_no_auth_on_a_public_bind_before_db_prepare
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new(bind: "0.0.0.0", auth: "none")
+      command.define_singleton_method(:rails_app_dir) { raise "must not locate or boot Rails" }
+
+      error = assert_raises(Hive::Error) { command.call }
+      assert_match(/refusing auth=none/, error.message)
+    end
+  end
   # Drive the full "app found" path with a stub Rails app: db:prepare
   # failure raises typed guidance (never a raw backtrace looping under the
   # container supervisor), and a passing prepare reaches Kernel.exec with
diff --git a/web/Gemfile b/web/Gemfile
index 53710d90..b46a31a2 100644
--- a/web/Gemfile
+++ b/web/Gemfile
@@ -70,4 +70,7 @@ end
 # The hive control plane: status payloads, gate approval, daemon dispatch,
 # the GitHub device-flow gate, the agent OAuth relay, and Telegram
 # validation all come from the gem — the web tier adds no pipeline logic.
-gem "hive-cli", path: ".."
+# Packaged web runtimes are copied under XDG data, so their parent is no
+# longer the Hive gem. Setup exports the exact active gem root; checkout use
+# retains the original relative path without requiring any special env.
+gem "hive-cli", path: ENV.fetch("HIVE_WEB_HIVE_GEM_PATH", File.expand_path("..", __dir__))
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28..5f96824e 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -11,7 +11,7 @@ class ApplicationController < ActionController::Base
 
   before_action :require_login
 
-  helper_method :current_login
+  helper_method :current_login, :local_no_auth?
 
   # Hive's typed errors are operator-readable by design ("task not in stage",
   # "invalid clone URL"). Render them on an error page instead of a blank
@@ -49,7 +49,12 @@ class ApplicationController < ActionController::Base
     session[:github_login]
   end
 
+  def local_no_auth?
+    ENV["HIVE_WEB_AUTH"] == "none"
+  end
+
   def require_login
+    return if local_no_auth?
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 00000000..e3cb8981
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,16 @@
+require "hive/daemon/repair"
+
+class DaemonController < ApplicationController
+  def repair
+    unless local_no_auth? && ENV["HIVEBOX_WEB_APP_DIR"].to_s.empty?
+      raise Hive::Error, "daemon repair is available only from local no-auth web mode; hivebox is supervised by its container"
+    end
+
+    result = Hive::Daemon::Repair.new.call
+    if result.status == :repaired
+      redirect_to root_path, notice: "Daemon repaired#{" (backup: #{result.backup_path})" if result.backup_path}."
+    else
+      redirect_to root_path, alert: result.message
+    end
+  end
+end
diff --git a/web/app/controllers/health_controller.rb b/web/app/controllers/health_controller.rb
index cda67e40..da9a3860 100644
--- a/web/app/controllers/health_controller.rb
+++ b/web/app/controllers/health_controller.rb
@@ -1,18 +1,8 @@
-require "hive/pid_file"
+require "hive/daemon/health"
 
 class HealthController < ApplicationController
   skip_before_action :require_login
 
-  # Reads the daemon's pidfile the same way `hive daemon status` does —
-  # stale files and reused PIDs don't count as alive.
-  class DaemonProbe
-    include Hive::PidFile
-
-    def pid_file
-      File.join(Hive::Paths.state_home, ".daemon.pid")
-    end
-  end
-
   # `/health` is web liveness (also the supervisor/installer smoke), while
   # `/health?deep=1` is the container readiness probe: the box is only
   # useful when the daemon child is running too — a crashlooping daemon
@@ -21,11 +11,12 @@ class HealthController < ApplicationController
   def show
     return render json: { ok: true } unless params[:deep].present?
 
-    daemon_pid = DaemonProbe.new.read_live_pid
-    if daemon_pid
-      render json: { ok: true, daemon: { running: true, pid: daemon_pid } }
+    daemon = Hive::Daemon::Health.current
+    if daemon.healthy?
+      render json: { ok: true, daemon: { running: true, pid: daemon.payload["pid"], identity: daemon.state } }
     else
-      render json: { ok: false, daemon: { running: false } }, status: :service_unavailable
+      render json: { ok: false, daemon: { running: daemon.state != :stopped, identity: daemon.state,
+                                         remediation: daemon.remediation } }, status: :service_unavailable
     end
   end
 end
diff --git a/web/app/controllers/sessions_controller.rb b/web/app/controllers/sessions_controller.rb
index f1fecfd8..6ba8bbe5 100644
--- a/web/app/controllers/sessions_controller.rb
+++ b/web/app/controllers/sessions_controller.rb
@@ -14,6 +14,7 @@ class SessionsController < ApplicationController
   class_attribute :http_client, default: Net::HTTP
 
   def new
+    return redirect_to root_path if local_no_auth?
     return redirect_to root_path if current_login
 
     # Surface a misconfigured box on the page itself — a sign-in button that
@@ -23,6 +24,7 @@ class SessionsController < ApplicationController
   end
 
   def create
+    return redirect_to root_path if local_no_auth?
     auth = github_auth
     raise Hive::Error, "GitHub sign-in is not configured: web.github.client_id is empty" unless auth.configured?
 
@@ -44,6 +46,7 @@ class SessionsController < ApplicationController
   # interval. Each render performs AT MOST one GitHub poll, gated by
   # `next_poll_at`, so refresh-happy tabs cannot trip GitHub's slow_down.
   def wait
+    return redirect_to root_path if local_no_auth?
     device = session[:github_device]
     return redirect_to login_path unless device
 
@@ -79,6 +82,7 @@ class SessionsController < ApplicationController
   end
 
   def destroy
+    return redirect_to root_path if local_no_auth?
     reset_session
     redirect_to login_path
   end
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a8..e76e4424 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -1,6 +1,9 @@
+require "hive/daemon/health"
+
 class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon_health = Hive::Daemon::Health.current
   end
 end
diff --git a/web/app/views/layouts/application.html.erb b/web/app/views/layouts/application.html.erb
index 77e0c5f9..c75659ef 100644
--- a/web/app/views/layouts/application.html.erb
+++ b/web/app/views/layouts/application.html.erb
@@ -24,17 +24,19 @@
     <header class="topbar">
       <div class="topbar-inner">
         <%= link_to "hivebox", root_path, class: "brand" %>
-        <% if current_login %>
+        <% if current_login || local_no_auth? %>
           <nav aria-label="Primary">
             <%= link_to "Status", root_path, class: nav_class(:status) %>
             <%= link_to "Repos", repos_path, class: nav_class(:repos) %>
             <%= link_to "Agents", agents_path, class: nav_class(:agents) %>
             <%= link_to "Telegram", telegram_path, class: nav_class(:telegram) %>
           </nav>
-          <div class="topbar-session">
-            <span class="session-login"><%= current_login %></span>
-            <%= button_to "Log out", logout_path, class: "btn btn-ghost btn-sm", form_class: "inline-form" %>
-          </div>
+          <% unless local_no_auth? %>
+            <div class="topbar-session">
+              <span class="session-login"><%= current_login %></span>
+              <%= button_to "Log out", logout_path, class: "btn btn-ghost btn-sm", form_class: "inline-form" %>
+            </div>
+          <% end %>
         <% end %>
       </div>
     </header>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf79..bf432389 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -9,6 +9,14 @@
 <% end %>
 <%= turbo_stream_from StatusBroadcaster::CHANNEL %>
 
+<section class="card daemon-health" aria-label="Daemon health">
+  <strong>Daemon: <%= @daemon_health.state %></strong>
+  <span class="muted"><%= @daemon_health.remediation %></span>
+  <% if local_no_auth? && @daemon_health.state != :match %>
+    <%= button_to "Repair daemon", daemon_repair_path, class: "btn btn-secondary btn-sm" %>
+  <% end %>
+</section>
+
 <%# TUI left-pane parity: the rail filters the grid client-side (buttons,
     not links — a navigation would discard the permanent composer's typed
     text). The controller wraps rail AND grid; it re-applies the filter
diff --git a/web/config/environments/production.rb b/web/config/environments/production.rb
index b991b661..c4ae0f58 100644
--- a/web/config/environments/production.rb
+++ b/web/config/environments/production.rb
@@ -1,4 +1,5 @@
 require "active_support/core_ext/integer/time"
+require "uri"
 
 Rails.application.configure do
   # Settings specified here will take precedence over those in config/application.rb.
@@ -82,11 +83,22 @@ Rails.application.configure do
   # Only use :id for inspections in production.
   config.active_record.attributes_for_inspect = [ :id ]
 
-  # Enable DNS rebinding protection and other `Host` header attacks.
-  # config.hosts = [
-  #   "example.com",     # Allow requests from example.com
-  #   /.*\.example\.com/ # Allow requests from subdomains like `www.example.com`
-  # ]
+  # Enable DNS rebinding protection and other `Host` header attacks. The CLI
+  # resolves a bind once before boot and exports it; never derive this policy
+  # from a request Host header. Docker starts Rails directly through the same
+  # command and retains its explicit GitHub-auth owner gate.
+  if (bind = ENV["HIVE_WEB_BIND"]).to_s != ""
+    hosts = [ bind ]
+    hosts << "localhost" if bind == "127.0.0.1" || bind == "::1" || bind == "localhost"
+    begin
+      origin_host = URI.parse(ENV.fetch("HIVE_WEB_ORIGIN", ENV.fetch("HIVEBOX_ORIGIN", ""))).host
+      hosts << origin_host if origin_host
+    rescue URI::InvalidURIError
+      # Config validation rejects invalid origins before web exec. This guard
+      # keeps an accidental environment override from crashing Rails boot.
+    end
+    config.hosts = hosts.uniq
+  end
   #
   # Skip DNS rebinding protection for the default health check endpoint.
   # config.host_authorization = { exclude: ->(request) { request.path == "/up" } }
@@ -94,10 +106,10 @@ Rails.application.configure do
   # Turbo Streams connect over Action Cable. Same-origin-as-host covers the
   # normal case with ZERO config — browse the box at any address and the
   # Origin header matches the Host header (also true behind proxies that
-  # forward Host). web.origin → HIVEBOX_ORIGIN remains as an explicit
+  # forward Host). web.origin → HIVE_WEB_ORIGIN remains as an explicit
   # additional allow for exotic setups where the two genuinely differ;
   # without same-origin, an unset origin silently dropped every live
   # update on any non-localhost URL — a trap on the install path.
   config.action_cable.allow_same_origin_as_host = true
-  config.action_cable.allowed_request_origins = [ ENV["HIVEBOX_ORIGIN"] ].compact
+  config.action_cable.allowed_request_origins = [ ENV["HIVE_WEB_ORIGIN"] || ENV["HIVEBOX_ORIGIN"] ].compact
 end
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df..230524d0 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -17,6 +17,8 @@ Rails.application.routes.draw do
 
   root "status#index"
 
+  post "daemon/repair" => "daemon#repair", as: :daemon_repair
+
   post "ideas" => "ideas#create", as: :ideas
 
   # Task pages are addressed by project name + task slug, mirroring the CLI.
diff --git a/web/test/integration/daemon_repair_test.rb b/web/test/integration/daemon_repair_test.rb
new file mode 100644
index 00000000..d5d816c8
--- /dev/null
+++ b/web/test/integration/daemon_repair_test.rb
@@ -0,0 +1,19 @@
+require "test_helper"
+
+class DaemonRepairTest < ActionDispatch::IntegrationTest
+  around do |test|
+    previous = ENV["HIVE_WEB_AUTH"]
+    ENV["HIVE_WEB_AUTH"] = "none"
+    test.call
+  ensure
+    previous.nil? ? ENV.delete("HIVE_WEB_AUTH") : ENV["HIVE_WEB_AUTH"] = previous
+  end
+
+  test "status renders a daemon health card in local mode" do
+    get "/"
+
+    assert_response :success
+    assert_match(/Daemon: stopped/, response.body)
+    assert_select "form[action='/daemon/repair']", 1
+  end
+end
diff --git a/web/test/integration/health_test.rb b/web/test/integration/health_test.rb
index 12d53aee..079d517d 100644
--- a/web/test/integration/health_test.rb
+++ b/web/test/integration/health_test.rb
@@ -27,7 +27,13 @@ class HealthTest < ActionDispatch::IntegrationTest
     # real start time passes the same liveness + ownership checks
     # `hive daemon status` applies.
     FileUtils.mkdir_p(File.dirname(pid_file))
-    File.write(pid_file, pid_file_payload(Process.pid).to_yaml)
+    File.write(
+      pid_file,
+      pid_file_payload(
+        Process.pid,
+        identity: { "invoked_binary" => Hive::InvokedBinary.path, "hive_version" => Hive::VERSION }
+      ).to_yaml
+    )
     get "/health", params: { deep: "1" }
     assert_response :success
     assert_equal Process.pid, response.parsed_body.dig("daemon", "pid")
diff --git a/web/test/integration/local_auth_test.rb b/web/test/integration/local_auth_test.rb
new file mode 100644
index 00000000..5559fd2a
--- /dev/null
+++ b/web/test/integration/local_auth_test.rb
@@ -0,0 +1,25 @@
+require "test_helper"
+
+class LocalAuthTest < ActionDispatch::IntegrationTest
+  around do |test|
+    previous = ENV["HIVE_WEB_AUTH"]
+    ENV["HIVE_WEB_AUTH"] = "none"
+    test.call
+  ensure
+    previous.nil? ? ENV.delete("HIVE_WEB_AUTH") : ENV["HIVE_WEB_AUTH"] = previous
+  end
+
+  test "loopback no-auth mode serves status without a GitHub session" do
+    get "/"
+
+    assert_response :success
+    assert_no_match(/Log out/, response.body)
+    assert_no_match(/Continue with GitHub/, response.body)
+  end
+
+  test "login endpoints do not create an owner session in no-auth mode" do
+    get "/login"
+
+    assert_redirected_to "/"
+  end
+end
